Imports System.ServiceProcess

Module Module1
    
    Sub Main()
        
        ' First get a look at all services
        Dim arServices() As ServiceController
        Dim objService As ServiceController
        Dim tsTime As New TimeSpan(0, 0, 30)
        
        arServices = ServiceController.GetServices("ssosa")
        
        For Each objService In arServices
            ' Print the name of all services
            Console.writeline(objService.DisplayName())
            
            ' Get the service we want to interrogate
            If objService.ServiceName = "QXMLTransfer" Then
                
                Console.WriteLine(objService.CanPauseAndContinue)
                Console.WriteLine(objService.CanShutdown)
                Console.WriteLine(objService.CanStop)
                
                If objservice.ServiceType = ServiceType.Win32OwnProcess Then
                    console.Writeline("Running in its own process")
                End If
                
                ' Get the most recent values                
                objService.Refresh()
                
                Try
                    ' Test for status values to make sure the service is running when we leave
                    Select Case objService.Status
                        Case ServiceControllerStatus.Stopped, ServiceControllerStatus.StopPending
                            objService.WaitForStatus(ServiceControllerStatus.Stopped, tsTime)
                            
                            objService.Refresh()
                            If objService.Status = ServiceControllerStatus.Stopped Then
                                objService.Start()
                            Else
                                Throw New exception("Could not get the service stopped.")
                            End If
                            
                        Case ServiceControllerStatus.Paused, ServiceControllerStatus.PausePending
                            objService.WaitForStatus(ServiceControllerStatus.Paused, tsTime)
                            
                            objService.Refresh()
                            If objService.Status = ServiceControllerStatus.Paused Then
                                objService.Continue()
                            Else
                                Throw New exception("Could not get the service paused.")
                            End If
                    End Select
                    
                    ' Make sure the service is running                
                    objService.WaitForStatus(ServiceControllerStatus.Running, tsTime)
                    
                    ' If not then raise an error
                    If objService.Status <> ServiceControllerStatus.Running Then
                        Throw New exception("Could not get the service started.")
                    End If
                    
                Catch e As Exception
                    Throw e
                Finally
                    ' Release the handle
                    objService.Close()
                End Try
                
            End If
            
            objService.Close()
        Next
        
        
    End Sub
    
End Module
