Imports System.ComponentModel
Imports System.Web.UI
Imports System.Data.SqlClient
Imports System.Data
Imports System.Configuration

<DefaultPropertyAttribute("ClassID"), ToolboxDataAttribute("<{0}:ClassData1 runat=server></{0}:ClassData1>")> _
Public Class ClassData : Inherits System.Web.UI.WebControls.WebControl

    Protected WithEvents txtMessage As System.Web.UI.HtmlControls.HtmlGenericControl
    Private strCourse As String
    Private strCost As String
    Private strLocation As String
    Private strDays As String
    Private strTime As String
    Private strSyllabus As String
    Private strProduct As String
    Private strVendor As String
    Private strCourseNum As String
    Private strClassDate As String

    Private Sub Control_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      txtMessage = New HtmlControls.HtmlGenericControl("<div>")

      If Me.ClassID = 0 Then
        txtMessage.InnerText = "The ClassID was not set properly"
      Else
        ' Query the database here for the class stuff
        Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("SQLConnect"))
        Dim cm As New SqlCommand("usp_GetClass", cn)
        Dim dr As SqlDataReader

        Try
          ' Execute the procedure and get the class values
          cm.CommandType = CommandType.StoredProcedure
          cm.Parameters.Add(New SqlParameter("@ClassID", SqlDbType.Int))
          cm.Parameters(0).Value = Me.ClassID

          cn.Open()
          dr = cm.ExecuteReader
          If dr.IsClosed Then
            txtMessage.InnerText = "No class found"
            Return
          Else
            dr.Read()
          End If

          strCourse = dr("Description").ToString
          strCourseNum = dr("CourseNum").ToString
          strLocation = dr("City").ToString
          strDays = dr("Days").ToString
          strTime = dr("StartTime").ToString
          strSyllabus = dr("Syllabus").ToString
          strClassDate = dr("ClassDate").ToString
          strProduct = dr("Product").ToString
          strVendor = dr("Vendor").ToString
          strCost = dr("Cost").ToString

          txtMessage.InnerText = "Here are the class details for the class you selected"
        Catch Ex As Exception
          txtMessage.InnerText = "An error occurred: " & Ex.Message

        Finally
          If Not dr Is Nothing Then dr.Close()
          cn.Close()
        End Try

      End If
    End Sub

    Protected Overrides Sub Render(ByVal output As System.Web.UI.HtmlTextWriter)
        Dim strImg As String

        ' Set the image to include
        Select Case strVendor
          Case "Microsoft"
            strImg = "http://www.quilogy.com/logo/ms-mctec.gif"
          Case "Oracle"
            strImg = "http://www.quilogy.com/images/banners/oracle.gif"
          Case "Sybase"
            strImg = "http://www.quilogy.com/logo/sybase-partner.gif"
        End Select
        output.Write("<img src='" & strImg & "' />")

        ' Set the message
        output.WriteFullBeginTag("div")
        output.Write(txtMessage.InnerHtml)
        output.WriteEndTag("div")
        output.Write("<hr>")

        ' Build the description
        output.Write("<b>Course:</b> " & strCourseNum & " " & strCourse & "<br>")
        output.Write("<b>Where?:</b> " & strLocation & _
          "  <a href='http://www.quilogy.com/loc-page.asp?location=" & strLocation & _
          "'>Need directions?</a><br>")
        output.Write("<b>When?:</b> " & strTime & " on " & strClassDate & "<br>")
        output.Write("<b>How Long?:</b> " & strDays & " days <br>")
        output.Write("<b>Product:</b> " & strProduct & "<br>")
        output.Write("<b>Retail Price:</b> " & strCost & "<br>")
        output.Write("<b>Vendor:</b> " & strVendor & "<br>")
        output.Write("<hr>")
        output.Write("<a href='" & strSyllabus & "'>Course Description</a>")
    End Sub

    <Bindable(True)> _
    Public Property ClassID() As Integer
    Get
      Return Me.ViewState("ClassID")
    End Get
    Set(ByVal Value As Integer)
      ' Save in the view state
      Me.ViewState("ClassID") = Value
    End Set
    End Property

End Class
