Option Strict On

Imports System.Drawing
Imports System.Web.Mobile
Imports System.Web.UI.MobileControls
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls
Imports System.Data.SqlClient
Imports System.Configuration
Imports Quilogy.Education
Imports Quilogy.Education.Schedule
Imports Quilogy.Education.Enrollment

Public Class QEducationMobile
  Inherits System.Web.UI.MobileControls.MobilePage
  Protected WithEvents Label1 As System.Web.UI.MobileControls.Label
  Protected WithEvents frmVendor As System.Web.UI.MobileControls.Form
  Protected WithEvents frmCity As System.Web.UI.MobileControls.Form
  Protected WithEvents Label2 As System.Web.UI.MobileControls.Label
  Protected WithEvents cboLocation As System.Web.UI.MobileControls.SelectionList
  Protected WithEvents cmdNext As System.Web.UI.MobileControls.Command
  Protected WithEvents frmSchedule As System.Web.UI.MobileControls.Form
  Protected WithEvents lblQuery As System.Web.UI.MobileControls.Label
  Protected WithEvents cmdGo As System.Web.UI.MobileControls.Command
  Protected WithEvents olClasses As System.Web.UI.MobileControls.ObjectList
  Protected WithEvents frmError As System.Web.UI.MobileControls.Form
  Protected WithEvents lblError As System.Web.UI.MobileControls.Label
  Protected WithEvents Register As System.Web.UI.MobileControls.PhoneCall
  Protected WithEvents frmMain As System.Web.UI.MobileControls.Form
  Protected WithEvents frmNewUser As System.Web.UI.MobileControls.Form
  Protected WithEvents Label4 As System.Web.UI.MobileControls.Label
  Protected WithEvents Label5 As System.Web.UI.MobileControls.Label
  Protected WithEvents Label6 As System.Web.UI.MobileControls.Label
  Protected WithEvents cmdRegister As System.Web.UI.MobileControls.Command
  Protected WithEvents cmdCancel As System.Web.UI.MobileControls.Command
  Protected WithEvents frmRegister As System.Web.UI.MobileControls.Form
  Protected WithEvents txtEmail As System.Web.UI.MobileControls.TextBox
  Protected WithEvents txtPwd As System.Web.UI.MobileControls.TextBox
  Protected WithEvents lstSelections As System.Web.UI.MobileControls.List
  Protected WithEvents lblWelcome As System.Web.UI.MobileControls.Label
  Protected WithEvents cmdVerify As System.Web.UI.MobileControls.Command
  Protected WithEvents frmTranscript As System.Web.UI.MobileControls.Form
  Protected WithEvents olTranscript As System.Web.UI.MobileControls.ObjectList
  Protected WithEvents cmdHome As System.Web.UI.MobileControls.Command
  Protected WithEvents cboVendor As System.Web.UI.MobileControls.SelectionList

#Region " Web Forms Designer Generated Code "

  '  'CODEGEN: This procedure is required by the Web Form Designer
  '  'Do not modify it using the code editor.
  Private Sub InitializeComponent()

  End Sub

  Private Sub Page_Init(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
    'CODEGEN: This method call is required by the Web Form Designer
    'Do not modify it using the code editor.
    InitializeComponent()

    olClasses.AutoGenerateFields = False

    Dim oField(5) As ObjectListField

    oField(0) = New ObjectListField()
    oField(0).DataField = "Description"
    oField(0).Title = "Class"
    olClasses.Fields.Add(oField(0))

    oField(1) = New ObjectListField()
    oField(1).DataField = "ClassDate"
    oField(1).Title = "Date"
    olClasses.Fields.Add(oField(1))

    oField(2) = New ObjectListField()
    oField(2).DataField = "CourseNum"
    oField(2).Title = "Course"
    olClasses.Fields.Add(oField(2))

    oField(3) = New ObjectListField()
    oField(3).DataField = "Days"
    oField(3).Title = "Days"
    olClasses.Fields.Add(oField(3))

    oField(4) = New ObjectListField()
    oField(4).DataField = "StartTime"
    oField(4).Title = "Time"
    olClasses.Fields.Add(oField(4))

    oField(5) = New ObjectListField()
    oField(5).DataField = "Product"
    oField(5).Title = "Product"
    olClasses.Fields.Add(oField(5))

    olTranscript.AutoGenerateFields = False

    Dim oTField(4) As ObjectListField

    oTField(0) = New ObjectListField()
    oTField(0).DataField = "CourseDesc"
    oTField(0).Title = "Class"
    olTranscript.Fields.Add(oTField(0))

    oTField(1) = New ObjectListField()
    oTField(1).DataField = "Date"
    oTField(1).Title = "Date"
    olTranscript.Fields.Add(oTField(1))

    oTField(2) = New ObjectListField()
    oTField(2).DataField = "CourseNum"
    oTField(2).Title = "Course"
    olTranscript.Fields.Add(oTField(2))

    oTField(3) = New ObjectListField()
    oTField(3).DataField = "Instructor"
    oTField(3).Title = "Instructor"
    olTranscript.Fields.Add(oTField(3))

    oTField(4) = New ObjectListField()
    oTField(4).DataField = "City"
    oTField(4).Title = "City"
    olTranscript.Fields.Add(oTField(4))

  End Sub

#End Region

  Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    'Put user code to initialize the page here
    If Not Me.IsPostBack Then
      Session("Validated") = False
      LoadControls()
      Me.ActiveForm = frmMain
      FindSubNo()
    End If
  End Sub

  Private Sub LoadControls()

    ' Load the drop downs

    ' Loads the other drop downs from the database
    ' This doesn't follow the tiered architecture but shows how multiple
    ' result sets can be retrieved from a single stored proc. This techniqueis
    ' application-specific which is why it doesn't follow the architecture

    Dim dr As SqlDataReader
    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("SQLConnect"))
    Dim cm As New SqlCommand("usp_GetSearch", cn)

    Try
      ' Open the connection and execute the DataReader
      cn.Open()
      cm.CommandType = CommandType.StoredProcedure
      dr = cm.ExecuteReader()

      ' Use Databinding
      With cboVendor
        .DataSource = dr
        .DataTextField = "Name"
        .DataValueField = "VendorID"
        .DataBind()
      End With

      ' Get the next resultset
      dr.NextResult()

      With cboLocation
        .DataSource = dr
        .DataTextField = "City"
        .DataValueField = "LocID"
        .DataBind()
      End With

    Catch E As Exception
      ' Go to an error form to show the exception
      Me.ActiveForm = frmError
      lblError.Text = "An error occurred: " & E.Message
    Finally
      dr.Close()
    End Try

  End Sub

  Private Sub cmdNext_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdNext.Click
    Me.ActiveForm = frmCity
  End Sub

  Private Sub cmdGo_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdGo.Click
    GetSchedule()
    Me.ActiveForm = frmSchedule
  End Sub

  Private Sub GetSchedule()
    Dim oClasses As Classes
    Dim dsSched As ScheduleData
    Dim flDesc As Boolean = False
    Dim intVendor As Integer
    Dim intLocation As Integer

    ' Set the message text
    lblQuery.Text = cboVendor.Selection.Text & ":" & cboLocation.Selection.Text & " 30 days out"

    ' Get the values from the drop downs
    intVendor = CType(cboVendor.Selection.Value(), Integer)
    intLocation = CType(cboLocation.Selection.Value(), Integer)

    ' Try and get the schedule
    Try
      oClasses = New Classes(ConfigurationSettings.AppSettings("SQLConnect"))
      dsSched = oClasses.GetSchedule(intLocation, intVendor)

      dsSched.OfferingsTable.Columns.Add(New DataColumn("myID", GetType(String), "CourseNum + ' ' + ClassDate"))
      olClasses.DataSource = dsSched.OfferingsTable.DefaultView

      Dim oField As New ObjectListField()
      oField.DataField = "myID"
      oField.Title = "ID"
      olClasses.Fields.Add(oField)
      oField.Visible = False

      olClasses.LabelField = "myID"
      olClasses.DataBind()

    Catch Ex As Exception
      Me.ActiveForm = frmError
      lblError.Text = "An error occurred: " & Ex.Message
    End Try

  End Sub

  Private Sub FindSubNo()
    If Not Request.ServerVariables("HTTP_X_UP_SUBNO") Is Nothing Then
      ' Coming in on a UP link
      Dim subNo As String

      subNo = Request.ServerVariables("HTTP_X_UP_SUBNO").ToString

      ' Check for association
      Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("SQLConnect"))
      Dim cm As New SqlCommand("usp_CheckSubNo", cn)
      Dim strVal As String

      Try
        cm.CommandType = CommandType.StoredProcedure
        cm.Parameters.Add(New SqlParameter("@SubNo", SqlDbType.VarChar))
        cm.Parameters(0).Value = subNo
        cm.Parameters.Add(New SqlParameter("@StudentID", SqlDbType.Int, 4, ParameterDirection.Output, False, 0, 0, Nothing, DataRowVersion.Default, Nothing))

        Dim parm As New SqlParameter("RETURN", SqlDbType.Int, 4, ParameterDirection.ReturnValue, False, 0, 0, Nothing, DataRowVersion.Default, Nothing)
        cm.Parameters.Add(parm)

        ' Open the connection and execute
        cn.Open()
        strVal = CStr(cm.ExecuteScalar())
        cn.Close()

        If CInt(parm.Value) = -1 Then
          ' If not there then do nothing else frmRegister and start a session
          Me.ActiveForm = frmRegister
        Else
          lblWelcome.Text = "Welcome " & strVal
          Session("Validated") = True
          Session("StudentID") = cm.Parameters(1).Value
        End If

      Catch e As Exception
        lblError.Text = "An error occured: " & e.Message
        Me.ActiveForm = frmError
      End Try

    End If
  End Sub

  Private Sub lstSelections_ItemCommand(ByVal source As Object, ByVal e As System.Web.UI.MobileControls.ListCommandEventArgs) Handles lstSelections.ItemCommand
    ' Navigate to the appropriate form
    Select Case e.ListItem.Value()
      Case "1"
        Me.ActiveForm = frmVendor
      Case "2"
        If Convert.ToBoolean(Session("Validated")) = False Then
          Me.ActiveForm = frmRegister
        Else
          Me.ActiveForm = frmTranscript
        End If
    End Select
  End Sub

  Private Sub cmdRegister_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRegister.Click
    Me.ActiveForm = frmNewUser
  End Sub

  Private Sub cmdCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCancel.Click
    Me.ActiveForm = frmMain
  End Sub

  Private Sub cmdVerify_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdVerify.Click

    ' Try and update the database
    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("SQLConnect"))
    Dim cm As New SqlCommand("usp_UpdateSubNo", cn)
    Dim strVal As String
    Dim subNo As String

    Try
      ' This only works on a UP network
      subNo = Request.ServerVariables("HTTP_X_UP_SUBNO").ToString

      cm.CommandType = CommandType.StoredProcedure
      cm.Parameters.Add(New SqlParameter("@SubNo", SqlDbType.VarChar))
      cm.Parameters(0).Value = subNo
      cm.Parameters.Add(New SqlParameter("@Email", SqlDbType.VarChar))
      cm.Parameters(1).Value = txtEmail.Text
      cm.Parameters.Add(New SqlParameter("@Pwd", SqlDbType.VarChar))
      cm.Parameters(2).Value = txtPwd.Text
      cm.Parameters.Add(New SqlParameter("@StudentID", SqlDbType.Int, 4, ParameterDirection.Output, False, 0, 0, Nothing, DataRowVersion.Default, Nothing))

      Dim parm As New SqlParameter("RETURN", SqlDbType.Int, 4, ParameterDirection.ReturnValue, False, 0, 0, Nothing, DataRowVersion.Default, Nothing)
      cm.Parameters.Add(parm)

      ' Open the connection and execute 
      cn.Open()
      strVal = CStr(cm.ExecuteScalar)
      cn.Close()

      If CInt(parm.Value) = -1 Then
        ' Could not update
        lblError.Text = "Could not update database"
        Me.ActiveForm = frmError
      Else
        lblWelcome.Text = "Welcome " & strVal
        Session("Validated") = True
        Session("StudentID") = cm.Parameters(3).Value
        Me.ActiveForm = frmMain
      End If

    Catch Ex As Exception
      lblError.Text = "An error occured: " & Ex.Message
      Me.ActiveForm = frmError
    End Try

  End Sub

  Private Sub cmdHome_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdHome.Click
    Me.ActiveForm = frmMain
  End Sub

  Private Sub GetTranscript()
    Dim oStud As Students
    Dim dsTrans As TranscriptData
    Dim dvSource As DataView

    Try
      ' Retrieve the transcript
      oStud = New Students(ConfigurationSettings.AppSettings("SQLConnect").ToString)
      dsTrans = oStud.GetTranscript(CInt(Session("StudentID")))

      dsTrans.ClassTable.Columns.Add(New DataColumn("myID", GetType(String), "CourseNum + ' ' + Date"))

      Dim oField As New ObjectListField()
      oField.DataField = "myID"
      oField.Title = "ID"
      olTranscript.Fields.Add(oField)
      oField.Visible = False

      olTranscript.LabelField = "myID"

      ' Bind the result to the Repeater control
      olTranscript.DataSource = dsTrans.ClassTable.DefaultView
      olTranscript.DataBind()

    Catch Ex As Exception
      lblError.Text = "An error occurred retrieving the transcript: " & Ex.Message
      Me.ActiveForm = frmError
    End Try

  End Sub

  Private Sub frmTranscript_Activate(ByVal sender As Object, ByVal e As System.EventArgs) Handles frmTranscript.Activate
    GetTranscript()
  End Sub
End Class
